package net.lensfrex;

public class RabbitAndTortoise {
    public void runTest() {
        Animal rabbit = new Animal("Rabbit", 16, 32);
        Animal tortoise = new Animal("Tortoise", 8, 32);

        new Thread(rabbit).start();
        new Thread(tortoise).start();
    }
}

class Animal implements Runnable {
    private final String name;

    private final int speed;
    private final int targetDistance;

    private int totalDistance = 0;

    public Animal(String name, int speed, int targetDistance) {
        this.name = name;
        this.speed = speed;
        this.targetDistance = targetDistance;
    }

    @Override
    public void run() {
        while (totalDistance <= targetDistance) {
            try {
                Thread.sleep((int) (Math.random() * 1000) + 500);
            } catch (Exception ignored) {
                return;
            }

            totalDistance += speed;
            System.out.printf("[%s] has run %d%n", name, totalDistance);
        }

        System.out.printf("[%s] has finish the game.%n", name);
    }
}
