package net.lensfrex;

public class Ticket {
    public void runTest() {
        TicketOffice ticketOffice = new TicketOffice();
        new Thread(ticketOffice, "0").start();
        new Thread(ticketOffice, "1").start();
        new Thread(ticketOffice, "2").start();
    }
}

class TicketOffice implements Runnable {
    private static int ticket = 8;

    @Override
    public void run() {
        String name = Thread.currentThread().getName();
        while(sellTicket(name));
    }

    private boolean sellTicket(String name) {
        synchronized (this) {
            if (ticket <= 0) {
                System.out.printf("[%s]: Ticket was sold out.%n", name);
                return false;
            }

            System.out.printf("TicketOffice '%s' is selling ticket No.%s%n", name, ticket);
            ticket--;

            try {
                Thread.sleep(128);
            } catch (Exception ignored) {
                return false;
            }
        }

        return true;
    }
}
