package net.lensfrex;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.URL;
import java.net.URLConnection;
import java.nio.charset.StandardCharsets;
import java.util.List;
import java.util.Map;
import java.util.Set;

public class URLConnectionResource {
    private static final String targetSite = "https://www.gnu.org/licenses/gpl-3.0.txt";
    public void startTest() {
        URLConnection urlConnection;
        try {
            urlConnection = new URL(targetSite).openConnection();

            Set<Map.Entry<String, List<String>>> headers = urlConnection.getHeaderFields().entrySet();

            for (Map.Entry<String, List<String>> header : headers) {
                String key = header.getKey();
                List<String> values = header.getValue();
                for (String value : values) {
                    System.out.printf("%s: %s%n", key, value);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
            return;
        }

        System.err.println("--------------------------------");

        try (BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(urlConnection.getInputStream(), StandardCharsets.UTF_8))) {
            String line = bufferedReader.readLine();
            for (int i = 0; line != null && i < 10; i++, line = bufferedReader.readLine()) {
                System.out.println(line);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}