package net.lensfrex.socket.client.controller;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.Socket;

public class ClientConnection {
    private final Socket socket;

    public ClientConnection(String host, int port) throws IOException {
        this.socket = new Socket(host, port);
    }

    public InputStream getInputStream() throws IOException {
        return socket.getInputStream();
    }

    public OutputStream getOutputStream() throws IOException {
        return socket.getOutputStream();
    }

    public void disconnect() throws IOException {
        socket.close();
    }

    public void finishOutput() throws IOException {
        socket.shutdownOutput();
    }

    public void finishInput() throws IOException {
        socket.shutdownInput();
    }
}
