package net.lensfrex.socket.common;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

public class Common {
    public static DataPack readDataPack(InputStream inputStream) {
        return readDataPack(Util.readAllData(inputStream));
    }

    public static DataPack readDataPack(byte[] dataPackBytes) {
        return DataPack.parse(dataPackBytes);
    }

    public static int writeMessage(String id, String message, OutputStream outputStream) throws IOException {
        MessageData messageData = new MessageData(id, message);

        return writeMessage(messageData, outputStream);
    }

    public static int writeMessage(MessageData message, OutputStream outputStream) throws IOException {
        return writeMessage(message.toBytes(), outputStream);
    }

    public static int writeMessage(byte[] data, OutputStream outputStream) throws IOException {
        return write(data, Constant.OPCODE_SEND_MESSAGE, outputStream);
    }

    public static int write(byte[] data, byte[] opcode, OutputStream outputStream) throws IOException {
        DataPack dataPack = new DataPack(opcode, data);

        return write(dataPack, outputStream);
    }

    public static int write(DataPack dataPack, OutputStream outputStream) throws IOException {
        outputStream.write(Constant.MAGIC_HEADER);
        outputStream.write(dataPack.toBytes());

        outputStream.flush();
        return dataPack.getDataLength();
    }
}
